Index: /trunk/src/org/expeditee/gui/PopupManager.java
===================================================================
--- /trunk/src/org/expeditee/gui/PopupManager.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/PopupManager.java	(revision 1102)
@@ -19,102 +19,94 @@
 package org.expeditee.gui;
 
-import java.awt.BasicStroke;
-import java.awt.Color;
-import java.awt.Component;
-import java.awt.Graphics;
-import java.awt.Graphics2D;
-import java.awt.Point;
-import java.awt.Rectangle;
-import java.awt.Stroke;
-import java.awt.geom.Area;
-import java.util.HashMap;
-import java.util.HashSet;
 import java.util.LinkedList;
-
-import javax.swing.JLayeredPane;
-import javax.swing.SwingUtilities;
+import java.util.List;
+
+import org.expeditee.core.Point;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.EcosystemManager.Ecosystem;
 
 /**
- * A centralized container for all custom popups in expeditee.
+ * A centralised container for all custom pop-ups in expeditee.
  * 
  * @author Brook Novak
  */
-public final class PopupManager implements DisplayIOObserver {
-	
+public final class PopupManager implements DisplayObserver
+{
 	/** Singleton */
-	private PopupManager() {} 
+	private static PopupManager _instance = null;
+	
+	/**
+	 * @return The singleton instance.
+	 */
+	public static PopupManager getInstance()
+	{
+		// Only valid for Swing ecosystems
+		if (EcosystemManager.getType() != Ecosystem.Swing) return null;
+		
+		// Construct the instance
+		if (_instance == null) _instance = new PopupManager();
+		
+		return _instance;
+	}
 	
 	/** Singleton */
-	private static PopupManager _instance = new PopupManager();
-	
-	/**
-	 * @return The singleton instance.
-	 */
-	public static PopupManager getInstance() {
-		return _instance;
-	}
-	
-	// popup->invoker
-	private HashMap<Popup, Component> _popups = new HashMap<Popup, Component>();
-	// quick ref to invokers
-	private HashSet<Component> _invokers = new HashSet<Component>();
-	
-	private LinkedList<AnimatedPopup> _animatingPopups = new LinkedList<AnimatedPopup>();
-	private AnimationThread _animationThread = null;
-
-	private final int ANIMATION_DURATION = 180; // Tume its takes for a maximize . minimize to animate. In ms.
-	private final int ANIMATION_RATE = 30; // in ms
-	
-	/**
-	 * Determines whether a given point is over a popup.
+	private PopupManager()
+	{
+	} 
+	
+	private LinkedList<Popup> _popups = new LinkedList<Popup>();
+
+	/** Time its takes for a maximise/minimise to animate, in milliseconds. */
+	//private final int ANIMATION_DURATION = 180;
+	/** in milliseconds. TODO: Expand. cts16 */
+	//private final int ANIMATION_RATE = 30;
+	
+	public void add(Popup p)
+	{
+		if (p == null) return;
+
+		synchronized(_popups) {
+			if (!_popups.contains(p)) _popups.add(p);
+		}
+	}
+	
+	public void remove(Popup p)
+	{
+		if (p == null) return;
+
+		synchronized(_popups) {
+			if (_popups.contains(p)) _popups.remove(p);
+		}
+	}
+	
+	public List<Popup> getPopups()
+	{
+		synchronized(_popups) {
+			return new LinkedList<Popup>(_popups);
+		}
+	}
+	
+	/**
+	 * Determines whether a given point is over a pop-up.
 	 * 
 	 * @param p
 	 * 
-	 * @return True if p is over a popup
+	 * @return True if p is over a pop-up
 	 * 
 	 * @throws NullPointerException
 	 * 		If p is null
 	 */
-	public boolean isPointOverPopup(Point p) {
+	public boolean isPointOverPopup(Point p)
+	{
 		if (p == null) throw new NullPointerException("p");
-		for (Popup pp : _popups.keySet()) {
-			if (pp.getBounds().contains(p)) {
-				return true;
+
+		synchronized(_popups) {
+			for (Popup popup : _popups) {
+				if (popup.getBounds().contains(p)) return true;
 			}
 		}
 		
 		return false;
-	}
-	
-	/**
-	 * Tests a component to see if it is in invoker of an existing popup.
-	 * 
-	 * @param c
-	 * 	Must not be null.
-	 * 
-	 * @return
-	 * 		True if c is an invoker
-	 * 
-	 * @throws NullPointerException
-	 * 		If c is null
-	 */
-	public boolean isInvoker(Component c) {
-		if (c == null) throw new NullPointerException("c");
-		return _invokers.contains(c);
-	}
-	
-	/**
-	 * Gets an invoker for a popup
-	 * 
-	 * @param p
-	 * 		The popup to get the invoker for.
-	 * 
-	 * @return
-	 * 		The invoker for the given popup.
-	 * 		Null if popup does not exist.
-	 */
-	public Component getInvoker(Popup p) {
-		if (p == null) throw new NullPointerException("p");
-		return _popups.get(p);
 	}
 	
@@ -130,15 +122,31 @@
 	 * 		If p is null
 	 */
-	public boolean isShowing(Popup p) {
+	public boolean isShowing(Popup p)
+	{
 		if (p == null) throw new NullPointerException("p");
-		return _popups.containsKey(p);
+
+		synchronized(_popups) {
+			return _popups.contains(p) && p.isShowing();
+		}
 	}
 	
 	/**
 	 * @return
-	 * 		True if a poup is showing. False otherwise.
-	 */
-	public boolean isAnyPopupsShowing () {
-		return !_popups.isEmpty();
+	 * 		True if a pop-up is showing. False otherwise.
+	 */
+	public boolean isAnyPopupsShowing()
+	{
+		synchronized(_popups) {
+			return !_popups.isEmpty();
+		}
+	}
+	
+	public void hideAutoHidePopups()
+	{
+		synchronized(_popups) {
+			for (Popup p : _popups) {
+				if (p.doesAutoHide()) p.hide();
+			}
+		}
 	}
 	
@@ -146,10 +154,12 @@
 	 * @return
 	 * 		True if the mouse click event for going back a frame should be consumed
-	 * 		Due to a popup requesting this event to be consumed currently showing.
-	 */
-	public boolean shouldConsumeBackClick() {
-		for (Popup p : _popups.keySet()) {
-			if (p.shouldConsumeBackClick())
-				return true;
+	 * 		due to a pop-up requesting this event to be consumed currently showing.
+	 */
+	public boolean shouldConsumeBackClick()
+	{
+		synchronized(_popups) {
+			for (Popup p : _popups) {
+				if (p.shouldConsumeBackClick()) return true;
+			}
 		}
 		
@@ -157,324 +167,6 @@
 	}
 	
-	/**
-	 * Clears all popups from the browser that are autohidden.
-	 * Stops animations.
-	 */
-	public void hideAutohidePopups() {
-		
-
-		// Get rid of all animations that are not non-auto-hidden pops that are expanding
-		synchronized (_animatingPopups) {
-			
-			LinkedList<AnimatedPopup> animationsToClear = new LinkedList<AnimatedPopup>();
-			
-			for (AnimatedPopup ap : _animatingPopups) {
-				if (!(ap.popup != null && !ap.popup.doesAutoHide())) {
-					animationsToClear.add(ap);
-				}
-			}
-			
-			_animatingPopups.removeAll(animationsToClear);
-			
-		}
-		
-		LinkedList<Popup> popupsToClear = new LinkedList<Popup>();
-		LinkedList<Component> invokersToClear = new LinkedList<Component>();
-
-		// Get ride of the actual popups
-		for (Popup p : _popups.keySet()) {
-			if (p.doesAutoHide()) {
-				
-				popupsToClear.add(p);
-				invokersToClear.add(_popups.get(p));
-				
-				p.invalidateAppearance();
-				p.setVisible(false);
-				Browser._theBrowser.getLayeredPane().remove(p);
-				p.onHide();
-			}
-		}
-		
-		assert (popupsToClear.size() == invokersToClear.size());
-		
-		for (int i = 0; i < popupsToClear.size(); i++) {
-			_popups.remove(popupsToClear.get(i));
-			_invokers.remove(invokersToClear.get(i));
-		}
-		
-
-		
-	}
-	
-	
-	
-//	public void hideAllPopups() {
-//		
-//		for (Popup p : _popups.keySet()) {
-//			invalidatePopup(p);
-//			p.setVisible(false);
-//			Browser._theBrowser.getLayeredPane().remove(p);
-//			p.onHide();
-//		}
-//		_popups.clear();
-//		_invokers.clear();
-//		
-//		// Get rid of all animations
-//		synchronized (_animatingPopups) {
-//			_animatingPopups.clear();
-//		}
-//	}
-	
-	public void frameChanged() {
-		// Remove any popups that are showing on the current frame
-		hideAutohidePopups();
-	}
-
-	/**
-	 * Hides a popup - if not already hidden.
-	 * 
-	 * @param p
-	 * 		Must not be null.
-	 * 
-	 * @throws NullPointerException
-	 * 		If p is null
-	 */
-	public void hidePopup(Popup p) {
-		if (p == null) throw new NullPointerException("p");
-		
-		if (!isShowing(p) && (!p.isVisible() || p.getParent() == null)) return;
-		
-
-		// Cancel any showing animations
-		synchronized (_animatingPopups) {
-			AnimatedPopup toRemove = null;
-			for (AnimatedPopup ap : _animatingPopups) {
-				if (ap.popup == p) {
-					toRemove = ap;
-					break;
-				}
-			}
-			if (toRemove != null)
-				_animatingPopups.remove(toRemove);
-		}
-
-		p.invalidateAppearance();
-		p.setVisible(false);
-		Browser._theBrowser.getLayeredPane().remove(p);
-		Component invoker = _popups.remove(p);
-		if (invoker != null) _invokers.remove(invoker);
-		p.onHide();
-		
-	}
-	
-	/**
-	 * Hides a popup - with animation. - if not already hidden.
-	 * 
-	 * @param p
-	 * 		Must not be null.
-	 * @param animator
-	 * 		Must not be null.
-	 * 
-	 * @throws NullPointerException
-	 * 		If p or animator is null
-	 * 
-	 */
-	public void hidePopup(Popup p, PopupAnimator animator) {
-		
-		if (p == null) throw new NullPointerException("p");
-		if (animator == null) throw new NullPointerException("animator");
-		
-		if (!isShowing(p) && (!p.isVisible() || p.getParent() == null)) return;
-		
-		hidePopup(p);
-		AnimatedPopup ap = new AnimatedPopup(
-				animator, 
-				System.currentTimeMillis(), 
-				null,
-				false,
-				p.getLocation());
-
-		animator.starting(false, p.getBounds());
-		
-		synchronized (_animatingPopups) {
-			_animatingPopups.add(ap);
-		}
-
-		if (_animationThread == null || !_animationThread.isAlive() || _animationThread.willDie) {
-			_animationThread = new AnimationThread();
-			_animationThread.start();
-		}
-	}
-	
-	
-	
-	/**
-	 * Displays a popup at a specific location.
-	 * 
-	 * @param p
-	 * 		Must not be null.
-	 * 
-	 * @param invoker 
-	 * 			The component responsible for showing the popup. can be null.
-	 * 			Used such that when invoker pressed, the popup will not auto hide.
-	 * 
-	 * @param loc
-	 * 		Must not be null.
-	 * 
-	 * @throws NullPointerException
-	 * 		If p or loc is null
-	 * 
-	 */
-	public void showPopup(Popup p, Point loc, Component invoker) {
-		if (p == null) throw new NullPointerException("p");
-		if (loc == null) throw new NullPointerException("animator");
-		
-		
-		if (_popups.containsKey(p)) return;
-
-		p.prepareToPaint();
-		p.setLocation(loc);
-		p.setVisible(true);
-
-		Browser._theBrowser.getLayeredPane().add(p, JLayeredPane.POPUP_LAYER, 0);
-
-		_popups.put(p, invoker);
-		if (invoker != null) _invokers.add(invoker);
-		
-		p.onShowing();
-		p.onShow();
-		
-		// Invalidate the popup border
-		if (p.getBorderThickness() > 0.0f) {
-			p.invalidateAppearance();
-		}
-	}
-	
-	/**
-	 * Displays a popup at a specific location - with animation.
-	 * 
-	 * @param p
-	 * 		Must not be null.
-	 * 
-	 * @param invoker 
-	 * 			The component responsible for showing the popup. can be null.
-	 * 			Used such that when invoker pressed, the popup will not auto hide.
-	 * 
-	 * @param loc
-	 * 		Must not be null.
-	 * 
-	 * @param animator
-	 * 		Must not be null.
-	 * 
-	 * @throws NullPointerException
-	 * 		If p, animator or loc is null
-	 */
-	public void showPopup(Popup p, Point loc, Component invoker, PopupAnimator animator) {
-		if (animator == null)
-			throw new NullPointerException("animator");
-		if (p == null)
-			throw new NullPointerException("p");
-		if (loc == null)
-			throw new NullPointerException("loc");
-		
-		if (_popups.containsKey(p)) return;
-		
-		_popups.put(p, invoker);
-		if (invoker != null) _invokers.add(invoker);
-		
-		
-		AnimatedPopup ap = new AnimatedPopup(
-				animator, 
-				System.currentTimeMillis(), 
-				p,
-				true,
-				loc);
-		
-		
-		animator.starting(true, new Rectangle(loc.x, loc.y, p.getWidth(), p.getHeight()));
-		
-		p.onShowing();
-		
-		synchronized (_animatingPopups) {
-			_animatingPopups.add(ap);
-		}
-
-		if (_animationThread == null || !_animationThread.isAlive() || _animationThread.willDie) {
-			_animationThread = new AnimationThread();
-			_animationThread.start();
-		}
-
-	}
-	
-	/**
-	 * Does a pure asynch animation with no popups involved.
-	 * 
-	 * For example you may want to have an effect such that an item is expanding
-	 * or moving into a new location on the screen.
-	 * 
-	 * @param animator
-	 * 		Must not be null.
-	 * 
-	 * @param target
-	 * 		Must not be null.
-	 * 
-	 * @throws NullPointerException
-	 * 		If animator or target is null
-	 * 
-	 */
-	public void doPureAnimation(PopupAnimator animator, Rectangle target) {
-		
-		if (animator == null)
-			throw new NullPointerException("animator");
-		if (target == null)
-			throw new NullPointerException("target");
-		
-		AnimatedPopup ap = new AnimatedPopup(
-				animator, 
-				System.currentTimeMillis(), 
-				null,
-				false,
-				target.getLocation());
-		
-		
-		animator.starting(true, target);
-
-		synchronized (_animatingPopups) {
-			_animatingPopups.add(ap);
-		}
-
-		if (_animationThread == null || !_animationThread.isAlive() || _animationThread.willDie) {
-			_animationThread = new AnimationThread();
-			_animationThread.start();
-		}
-		
-	}
-	
-
-	/**
-	 * Paints all popups in the browsers popup pane with the given graphics.
-	 * 
-	 * @param g
-	 * 		Where to paint to.
-	 * 
-	 * @param clip
-	 */
-	void paintLayeredPane(Graphics g, Area clip) {
-		 if (Browser._theBrowser == null) return;
-		 
-		Component[] compsOnPopup = Browser._theBrowser.getLayeredPane().getComponentsInLayer(JLayeredPane.POPUP_LAYER);
-
-		for (int i = 0; i < compsOnPopup.length; i++) {
-			Component c = compsOnPopup[i];
-	
-			Point p = c.getLocation();
-
-			if (clip == null || clip.intersects(c.getBounds())) {
-				g.translate(p.x, p.y);
-				c.paint(g);
-				g.translate(-p.x, -p.y);
-			}
-			
-		} 
+	public void frameChanged()
+	{
 	}
 
@@ -482,339 +174,163 @@
 	 * Paints current popup animations to the expeditee browser content pane.
 	 */
-	void paintAnimations() {
-		
-		if (Browser._theBrowser == null
-				|| Browser._theBrowser.g == null) return;
-		
-		Graphics g = Browser._theBrowser.g;
-		
-		synchronized (_animatingPopups) {
-			
-			for (AnimatedPopup ap : _animatingPopups) {
-				ap.animator.paint(g);
-			}
-			
-		}
-	}
-	
-	/**
-	 * Proccesses animation on a dedicated thread.
+	public void paint()
+	{
+		synchronized (_popups) {
+			for (Popup popup : _popups) {
+				popup.update();
+				popup.paint();
+			}
+		}
+	}
+	
+	/**
+	 * Provides animations for a popup when hiding or when showing.
+	 * 
+	 * Note that {@link PopupAnimator#paint(Graphics)} and {@link PopupAnimator#update(float)} 
+	 * will always be invoked at seperate times - so do not have to worry about thread-safety.
+	 * 
+	 * These should only be used once... one per popup at a time.
 	 * 
 	 * @author Brook Novak
-	 *
-	 */
-	private class AnimationThread extends Thread {
-		
-		private boolean willDie = false;
+	 */
+	public static abstract class PopupAnimator
+	{
+		/** True if animating to show the popup, false if to hide. */
+		private boolean _showing = true;
+		
+		/** Whether the animation is currently paused. */
+		private boolean _paused = true;
+		
+		private long _startTime;
+		private long _duration;
+		private long _animationCurrentTime;
+		
+		public PopupAnimator()
+		{
+			_animationCurrentTime = _startTime = System.currentTimeMillis();
+			_duration = getDurationMillis();
+		}
+		
+		/**
+		 * @return False if the animation has finished, true if further updates are required.
+		 */
+		public boolean update()
+		{
+			long currentTime = System.currentTimeMillis();
+			
+			if (currentTime > _startTime + _duration) {
+				currentTime = _startTime + _duration;
+			}
+			
+			// If paused, make sure elapsed time stays constant
+			if (_paused) {
+				_startTime += currentTime - _animationCurrentTime;
+			}
+			
+			_animationCurrentTime = currentTime;
+			
+			return !isFinished();
+		}
+		
+		public void hide()
+		{
+			if (!_showing) return;
+			
+			_showing = false;
+			complementAnimationProgress();
+		}
+		
+		public void show()
+		{
+			if (_showing) return;
+			
+			_showing = true;
+			complementAnimationProgress();
+		}
+		
+		public boolean isShowing()
+		{
+			return _showing;
+		}
+		
+		public void start()
+		{
+			_animationCurrentTime = _startTime = System.currentTimeMillis();
+			unpause();
+		}
+		
+		public void pause()
+		{
+			pause(true);
+		}
+		
+		public void unpause()
+		{
+			pause(false);
+		}
+		
+		public void pause(boolean pause)
+		{
+			_paused = pause;
+		}
+		
+		private void complementAnimationProgress()
+		{
+			_startTime = _animationCurrentTime - ((_startTime + _duration) - _animationCurrentTime);
+		}
+		
+		public float getProgress()
+		{
+			return (_animationCurrentTime - _startTime) / ((float) _duration);
+		}
+		
+		public boolean isFinished()
+		{
+			return _animationCurrentTime != _startTime + _duration;
+		}
+		
+		public abstract long getDurationMillis();
+		
+		public abstract AxisAlignedBoxBounds getAnimatedBounds(AxisAlignedBoxBounds fullBounds);
+		
+	}
+	
+	public static class ExpandShrinkAnimator extends PopupAnimator
+	{
+		public static final long DURATION_MS = 2000;
+		
+		public AxisAlignedBoxBounds _initialBounds = null;
+		
+		public ExpandShrinkAnimator()
+		{
+		}
+		
+		public ExpandShrinkAnimator(AxisAlignedBoxBounds initialBounds)
+		{
+			setInitialBounds(initialBounds);
+		}
+		
+		public void setInitialBounds(AxisAlignedBoxBounds initialBounds)
+		{
+			_initialBounds = initialBounds;
+		}
 		
 		@Override
-		public void run() {
-			
-			
-			 LinkedList<AnimatedPopup> finishedAnimations;
-			 
-			 while (true) {
-			 
-				 // Perform animation logic
-				 finishedAnimations = animate();
-				
-				 // Check if finished all animations
-				 if (finishedAnimations == null) return; // done
-				 
-				 // Check for finalization of animation. That is, adding the popups to the layered pane
-				 boolean needsFinalization = false;
-				 for (AnimatedPopup ap : finishedAnimations) {
-					 if (ap.isShowing) {
-						 needsFinalization = true;
-						 break;
-					 } 
-					 
-					 // FInal invalidation
-					 FrameGraphics.invalidateArea(ap.animator.getCurrentDrawingArea());
-					 
-				 }
-				 
-				 if (needsFinalization) {
-					 SwingUtilities.invokeLater(new AnimationFinalizor(finishedAnimations));
-					 // Will repaint when a popup becomes anchored...
-				 } else {
-					 FrameGraphics.requestRefresh(true);
-				 }
-
-				 // Limit animation rate
-				 try {
-					 sleep(ANIMATION_RATE);
-				 } catch (InterruptedException e) {
-					e.printStackTrace();
-				 }
-			
-			 }
-			
-		}
-		
-		/**
-		 * Performs animations
-		 * @return
-		 */
-		private LinkedList<AnimatedPopup> animate() {
-			
-			LinkedList<AnimatedPopup> finishedPopups = null;
-			
-			synchronized (_animatingPopups) {
-				
-				if (_animatingPopups.isEmpty()) {
-					willDie = true;
-					return null;
-				}
-
-				long currentTime = System.currentTimeMillis();
-				
-				finishedPopups = new LinkedList<AnimatedPopup>();
-				
-				for (AnimatedPopup ap : _animatingPopups) {
-					
-					long duration = currentTime - ap.startTime;
-					
-					if (duration >= ANIMATION_DURATION) { // check if complete
-						
-						finishedPopups.add(ap);
-	
-					} else {
-						
-						float percent = ((float)duration / (float)ANIMATION_DURATION);
-						assert (percent >= 0.0f);
-						assert (percent < 1.0f);
-						
-						Rectangle dirty = ap.animator.update(percent);
-						if (dirty != null)
-							FrameGraphics.invalidateArea(dirty);
-						
-					}
-
-				}
-				
-				_animatingPopups.removeAll(finishedPopups);
-				
-			}
-			
-			return finishedPopups;
-			
-		}
-		
-		/**
-		 * Adds popups to layered pane
-		 * @author Brook Novak
-		 *
-		 */
-		private class AnimationFinalizor implements Runnable {
-
-			private LinkedList<AnimatedPopup> finished;
-			
-			AnimationFinalizor(LinkedList<AnimatedPopup> finished) {
-				this.finished = finished;
-			}
-			
-			public void run() {
-				
-				for (AnimatedPopup ap : finished) {
-					
-					if (ap.isShowing && _popups.containsKey(ap.popup)) {
-
-						ap.popup.prepareToPaint();
-						ap.popup.setLocation(ap.popupLocation);
-						ap.popup.setVisible(true);
-
-						Browser._theBrowser.getLayeredPane().add(ap.popup, JLayeredPane.POPUP_LAYER, 0);
-						
-						ap.popup.onShow();
-						
-						// Invalidate the popup border
-						if (ap.popup.getBorderThickness() > 0.0f) {
-							ap.popup.invalidateAppearance();
-						}
-					}
-					
-				}
-				
-			}
-		}
-	}
-	
-	private class AnimatedPopup {
-		
-		PopupAnimator animator;
-		long startTime;
-		Popup popup = null;
-		boolean isShowing;
-		Point popupLocation;
-		
-		public AnimatedPopup(PopupAnimator animator, long startTime, Popup popup, 
-				boolean isShowing, Point popupLocation) {
-			
-			assert(animator != null);
-			assert(popupLocation != null);
-			
-			// Only have popup if showing
-			assert (!isShowing && popup == null || (isShowing && popup != null));
-			
-			
-			this.animator = animator;
-			this.startTime = startTime;
-			this.popup = popup;
-			this.isShowing = isShowing;
-			this.popupLocation = popupLocation;
-
-		}
-
-	}
-	
-	/**
-	 * Provides animations for a popup when hiding or when showing.
-	 * 
-	 * Note that {@link PopupAnimator#paint(Graphics)} and {@link PopupAnimator#update(float)} 
-	 * will always be invoked at seperate times - so do not have to worry about thread-saefty.
-	 * 
-	 * These should only be used once... one per popup at a time.
-	 * 
-	 * @author Brook Novak
-	 *
-	 */
-	public interface PopupAnimator {
-		
-		/**
-		 * Invoked before showing. Any prepaations are done here.
-		 * 
-		 * @param isShowing
-		 * 		True if this animation will be for a popup that is showing.
-		 * 		False if this animation will be for a popup that is hiding.
-		 * 
-		 * @param popupBounds
-		 * 		The location of the popup. I.E. where it is, or where it will be.
-		 * 
-		 */
-		void starting(boolean isShowing, Rectangle popupBounds);
-		
-		/**
-		 * 
-		 * Called on an animation thread.
-		 * 
-		 * @param percent
-		 * 		The percent complete of the animations.
-		 * 		Rangles from 0 to 1.
-		 * 
-		 * @return dirty area that needs painting for last update... Null for no invalidation
-		 * 		
-		 * 
-		 */
-		Rectangle update(float percent);
-		
-		/**
-		 * Paints the animation - on the swing thread.
-		 * Note that this is always on the content pane - not the expeditee frame buffer.
-		 * 
-		 * @param g
-		 * 
-		 */
-		void paint(Graphics g);
-		
-		
-		/**
-		 * 
-		 * @return
-		 * 		The area which the animation is drawn. Used for final invalidation. Null for no final invaliation
-		 */
-		Rectangle getCurrentDrawingArea();
-		
-	}
-	
-	
-	public class ExpandShrinkAnimator implements PopupAnimator {
-		
-		private boolean isShowing;
-		private Rectangle popupBounds;
-		private Rectangle sourceRectangle;
-		private Rectangle currentRectangle;
-		private Color fillColor;
-		
-		private final Stroke stroke = new BasicStroke(2.0f);
-		
-		/**
-		 * 
-		 * @param sourceRectangle
-		 * @param fillColor
-		 * 		The fill color of the animated rectangle. Null for no fill.
-		 */
-		public ExpandShrinkAnimator(Rectangle sourceRectangle, Color fillColor) {
-			if (sourceRectangle == null) throw new NullPointerException("sourceRectangle");
-			
-			this.fillColor = fillColor;
-			this.sourceRectangle = (Rectangle)sourceRectangle.clone();
-			this.currentRectangle = (Rectangle)sourceRectangle.clone();
-		}
-
-		public void paint(Graphics g) {
-			
-			if (fillColor != null) {
-				g.setColor(fillColor);
-				g.fillRect(currentRectangle.x, currentRectangle.y, currentRectangle.width, currentRectangle.height);
-			}
-			
-			g.setColor(Color.BLACK);
-			((Graphics2D)g).setStroke(stroke);
-			g.drawRect(currentRectangle.x, currentRectangle.y, currentRectangle.width, currentRectangle.height);
-		}
-
-		public void starting(boolean isShowing, Rectangle popupBounds) {
-			this.isShowing = isShowing;
-			this.popupBounds = popupBounds;
-			
-			if (isShowing) {
-				this.currentRectangle = (Rectangle)sourceRectangle.clone();
-			} else {
-				this.currentRectangle = (Rectangle)sourceRectangle.clone();
-			}
-			
-		}
-
-		public Rectangle update(float percent) {
-
-			Rectangle oldBounds = currentRectangle;
-			
-			if (!isShowing) { // if minimizing just reverse percent
-				percent = 1 - percent;
-			}
-			
-			// update X
-			currentRectangle.x = sourceRectangle.x + 
-				(int)((popupBounds.x - sourceRectangle.x) * percent);
-			
-			// update Y
-			currentRectangle.y = sourceRectangle.y + 
-				(int)((popupBounds.y - sourceRectangle.y) * percent);
-			
-			// update width
-			currentRectangle.width = sourceRectangle.width + 
-				(int)((popupBounds.width - sourceRectangle.width) * percent);
-			
-			// update height
-			currentRectangle.height = sourceRectangle.height + 
-				(int)((popupBounds.height - sourceRectangle.height) * percent);
-			
-			int x = Math.min(oldBounds.x, currentRectangle.x);
-			int y = Math.min(oldBounds.y, currentRectangle.y);
-			int width = Math.min(oldBounds.x + oldBounds.width, currentRectangle.x + currentRectangle.width) - x;
-			int height = Math.min(oldBounds.y + oldBounds.height, currentRectangle.y + currentRectangle.height) - y;
-			
-			return new Rectangle(x, y, width, height);
-			
-		}
-		
-		public Rectangle getCurrentDrawingArea() {
-			return currentRectangle;
-		}
-
-
-	}
-	
-
+		public long getDurationMillis() { return DURATION_MS; }
+
+		@Override
+		public AxisAlignedBoxBounds getAnimatedBounds(AxisAlignedBoxBounds fullBounds)
+		{
+			if (_initialBounds == null) {
+				setInitialBounds(fullBounds.clone());
+				_initialBounds.getTopLeft().y += _initialBounds.getSize().height; 
+				_initialBounds.getSize().height = 0;
+			}
+			
+			float percentShown = getProgress();
+			if (!isShowing()) percentShown = 1 - percentShown;
+			
+			return AxisAlignedBoxBounds.lerp(_initialBounds, fullBounds, percentShown);
+		}
+	}
 }
Index: /trunk/src/org/expeditee/gui/Reminders.java
===================================================================
--- /trunk/src/org/expeditee/gui/Reminders.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Reminders.java	(revision 1102)
@@ -19,10 +19,10 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
 import java.util.Date;
 
+import org.expeditee.Util;
 import org.expeditee.actions.Misc;
+import org.expeditee.core.Colour;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.charts.TimeSeries;
 
 public class Reminders {
@@ -46,5 +46,5 @@
 				}
 
-				Date date = TimeSeries.parseDate(dateString);
+				Date date = Util.parseDate(dateString);
 				long millisToWait = date.getTime() - new Date().getTime();
 				final long adjustedToWait;
@@ -69,5 +69,5 @@
 								MessageBay.displayMessage(
 										"Reminder: " + reminderString, null,
-										Color.red, false, "StopReminder");
+										Colour.RED, false, "StopReminder");
 								Thread.sleep(5000);
 								// newMessage.setColor(new Color(100, 70, 70));
Index: /trunk/src/org/expeditee/gui/Vector.java
===================================================================
--- /trunk/src/org/expeditee/gui/Vector.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Vector.java	(revision 1102)
@@ -19,28 +19,38 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.awt.Dimension;
-import java.awt.Point;
 import java.text.NumberFormat;
 
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Point;
 import org.expeditee.items.Item;
 import org.expeditee.items.UserAppliedPermission;
 
+/**
+ * TODO: Explain WTF this is. cts16
+ */
 public class Vector extends Overlay {
 
+	/** TODO: Comment. cts16 */
 	public Point Origin;
 
+	/** TODO: Comment. cts16 */
 	public float Scale;
 
-	public Color Foreground;
+	/** TODO: Comment. cts16 */
+	public Colour Foreground;
 
-	public Color Background;
-	
+	/** TODO: Comment. cts16 */
+	public Colour Background;
+
+	/** TODO: Comment. cts16 */
 	public Item Source;
-	
+
+	/** TODO: Comment. cts16 */
 	public Dimension Size;
 
-	public Vector(Frame overlay, UserAppliedPermission permission,
-			Float scale, Item source) {
+	/** TODO: Comment. cts16 */
+	public Vector(Frame overlay, UserAppliedPermission permission, Float scale, Item source)
+	{
 		super(overlay, permission);
 		Origin = source.getPosition();
@@ -52,38 +62,46 @@
 
 	@Override
-	public boolean equals(Object o) {
-		if (o == null || o.getClass() != Vector.class)
-			return false;
-		Vector v = (Vector) o;
-
-		return v.Frame == Frame && Origin.equals(v.Origin)
-				&& Scale == v.Scale && Foreground == v.Foreground
-				&& Background == v.Background;
+	public boolean equals(Object o)
+	{
+		if (o instanceof Vector) {
+			Vector v = (Vector) o;
+			return v.Frame == Frame &&
+					Origin.equals(v.Origin) &&
+					Scale == v.Scale &&
+					Foreground.equals(v.Foreground) &&
+					Background.equals(v.Background);
+		}
+		
+		return false;
+		
 	}
 
 	@Override
-	public int hashCode() {
+	public int hashCode()
+	{
 		return 0;
 	}
 
-	/**
-	 * Converts the given x position to be relative to the overlay frame.
-	 * 
-	 * @param x
-	 * @return
-	 */
-	public float getX(int x) {
+	/** Converts the given x position to be relative to the overlay frame. */
+	public float getX(int x)
+	{
 		return (x - Origin.x) / Scale;
 	}
 
-	public float getY(int y) {
+	/** Converts the given y position to be relative to the overlay frame. */
+	public float getY(int y)
+	{
 		return (y - Origin.y) / Scale;
 	}
 
-	public void setSize(int maxX, int maxY) {
+	/** TODO: Comment. cts16 */
+	public void setSize(int maxX, int maxY)
+	{
 		Size = new Dimension(maxX, maxY);
 	}
 
-	public static NumberFormat getNumberFormatter() {
+	/** TODO: Comment. cts16 */
+	public static NumberFormat getNumberFormatter()
+	{
 		NumberFormat nf = NumberFormat.getInstance();
 		nf.setMaximumFractionDigits(4);
Index: /trunk/src/org/expeditee/importer/FileImporter.java
===================================================================
--- /trunk/src/org/expeditee/importer/FileImporter.java	(revision 1101)
+++ /trunk/src/org/expeditee/importer/FileImporter.java	(revision 1102)
@@ -19,8 +19,8 @@
 package org.expeditee.importer;
 
-import java.awt.Point;
 import java.io.File;
 import java.io.IOException;
 
+import org.expeditee.core.Point;
 import org.expeditee.items.Item;
 
Index: /trunk/src/org/expeditee/importer/FilePathImporter.java
===================================================================
--- /trunk/src/org/expeditee/importer/FilePathImporter.java	(revision 1101)
+++ /trunk/src/org/expeditee/importer/FilePathImporter.java	(revision 1102)
@@ -19,8 +19,9 @@
 package org.expeditee.importer;
 
-import java.awt.Point;
 import java.io.File;
 import java.io.IOException;
 
+import org.expeditee.core.Point;
+import org.expeditee.gio.DragAndDropManager;
 import org.expeditee.items.Item;
 
@@ -36,5 +37,5 @@
 	public Item importFile(File f, Point location) throws IOException {
 		if (location != null && f != null) {
-			return FrameDNDTransferHandler.importString(f.getAbsolutePath(), location);			
+			return DragAndDropManager.importString(f.getAbsolutePath(), location);			
 		}
 
